<?php

/**
 * Description of MCFormWidget
 *
 * @author Arian Khosravi <arian@bigemployee.com>, <@ArianKhosravi>
 */
class MCFormWidget extends WP_Widget {

    public function __construct() {
        parent::__construct(
                'MCFormWidget', 'BigMailChimp', array('description' => __('Display a MailChimp capture form in widget area', 'text_domain'))
        );
    }

    public function widget($args, $instance) {
        extract($args);
        $list_id = strip_tags($instance['list_id']);
        $description = strip_tags($instance['description']);
        $MCMapper = new MCListMapper();
        if ($MClist = $MCMapper->find($list_id, new MCList())) {
            $api = new MCAPI($MClist->getApi_key());
            $list_prop = $api->lists(array('list_id' => $MClist->getList_id()));
            $form = new Forms_MCGenerated($list_prop['data'][0]['web_id'], BIGMAILCHIMP_URL."includes/mc.php?id=" . $MClist->getId(), 'post', NULL,
                            array('apiKey' => $MClist->getApi_key(), 'listId' => $MClist->getList_id()));
            echo '<div class="bigmailchimp-widget">';
            echo '<p>'.$description.'</p>';
            echo $form->print_form();
            echo '</div>';
        }
    }

    public function update($new_instance, $old_instance) {
        $instance = array();
        $list_id = strip_tags($new_instance['list_id']);
        $MCMapper = new MCListMapper();
        if ($MClist = $MCMapper->find($list_id, new MCList())) {
            $api = new MCAPI($MClist->getApi_key());
            $list_prop = $api->lists(array('list_id' => $MClist->getList_id()));
            $instance['list_id'] = $list_id;
            $instance['title'] = strip_tags($list_prop['data'][0]['name']);
        }
        $instance['description'] = $new_instance['description'];
        return $instance;
    }

    public function form($instance) {
        $str = '';
        $mcMapper = new MCListMapper();
        $mc_lists = $mcMapper->fetchAll();
        $list_id = isset($instance['list_id'])? $instance['list_id']:-1;
        $title = isset($instance['title'])? $instance['title']: __('New title', 'text_domain');
        $description = isset($instance['description'])?$instance['description']:__('','text_domain');


        $str .= '<input id = "' . $this->get_field_id('title') . '" name = "' . $this->get_field_name('title') .
                '" type = "hidden" value = "' . esc_attr($title) . '" />';

        $str .= '<label for="'.$this->get_field_id('description').'">Description</label>';
        $str .= '<textarea id = "' . $this->get_field_id('description') . '" name = "' . $this->get_field_name('description') .
                '" class="widefat">' . esc_attr($description) . '</textarea>';

        $str .= '<p>Select the list you want to include on the page/post.</p>';
        $str .= '<p><select name="' . $this->get_field_name('list_id') . '">';
        $str .= '<option value="">Select one...</option>';
        foreach ($mc_lists as $list) {
            $api = new MCAPI($list->getApi_key());
            $list_prop = $api->lists(array('list_id' => $list->getList_id()));
            $str .= '<option value="' . $list->getId() . '" ' .
                    ($list_id == $list->getId() ? 'selected="selected"' : '') . '>' .
                    $list_prop['data'][0]['name'] . '</option>';
        }
        $str .= '</select></p>';
        echo $str;
    }

}
?>