<?php

define('WP_USE_THEMES', false);
require_once('../../../../wp-load.php');
include_once '../library/Loader.php';
Loader::init();
$messages = array();
if (!empty($_POST) && !empty($_GET['id'])) {
    $id = strip_tags(trim($_GET['id']));
    $mcMapper = new MCListMapper();
    $mcList = $mcMapper->find($id, new MCList());
    $mcapi = new MCAPI($mcList->getApi_key());
    $groupings = $mcapi->listInterestGroupings($mcList->getList_id());
    $merge_vars = array();
    $group_ids = array();

    if (is_array($groupings)) {
        foreach ($groupings as $grouping) {
            $group_ids[$grouping['id']] = $grouping['name'];
            $merge_vars['GROUPINGS'][] = array('name' => $grouping['name'],
                'groups' => '');
        }
    }

    $email = strip_tags(trim($_POST['EMAIL']));
    if (!empty($_POST['EMAILTYPE'])) {
        $email_type = strtolower(strip_tags(trim($_POST['EMAILTYPE'])));
        unset($_POST['EMAILTYPE']);
    } else {
        $email_type = 'html';
    }
    unset($_POST['EMAIL']);
    foreach ($_POST as $key => $value) {
        if (array_key_exists($key, $group_ids)) {
            $merge_vars['GROUPINGS'][] = array(
                'name' => $group_ids[$key],
                'groups' => implode(',', $value));
        } else {
            $merge_vars[$key] = $value;
        }
    }

//    id, email_address, merge_vars, email_type, double_optin, update_existing, replace_interests, send_welcome
    $subscribed = $mcapi->listSubscribe($mcList->getList_id(), $email, $merge_vars, $email_type, true, false, true, true);
    if ($mcapi->errorCode == 214) { // user exists
        $updated = $mcapi->listUpdateMember($mcList->getList_id(), $email, $merge_vars, $email_type, true);
    }
    if ($mcapi->errorCode) {
        $messages['status'] = "error";
        $messages[] = $mcapi->errorMessage;
    } else {
        $messages['status'] = "success";
        $messages[] = "Subscribed - You will receive an email confirmation shortly!";
    }
}
echo json_encode($messages);
?>