<?php

/**
 * Description of FormInterface
 *
 * @author Arian Khosravi <arian@bigemployee.com>, <@ArianKhosravi>
 */
abstract class Forms_FormAbstract {

    protected $_form;

    abstract public function print_form();

    public function __construct($form_id, $action = '', $method = 'post', $layout = null, array $options = null) {
        $this->_form = new Forms_Form($form_id, $action, $method, $layout);
        if (is_array($options))
            $this->setOptions($options);
    }

    public function __get($name) {
        $method = 'get' . $name;
        if ("mapper" == $name || !method_exists($this, $method))
            throw new Exception('call to invalid method ' . $method);
        return $this->$method();
    }

    public function __set($name, $value) {
        $method = 'set' . $name;
        if ('mapper' == $name || !method_exists($this, $method))
            throw new Exception('call to invalid method ' . $method);
        $this->$method($value);
    }

    public function setOptions(array $options = NULL) {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods))
                $this->$method($value);
        }
        return $this;
    }

    public function getForm() {
        return $this->_form;
    }

}

?>