<?php

class Forms_MCGenerated extends Forms_FormAbstract {

    protected $_apiKey;
    protected $_listId;

    public function setApiKey($_apiKey) {
        $this->_apiKey = $_apiKey;
        return $this;
    }

    public function getApiKey() {
        return $this->_apiKey;
    }

    public function setListId($_listID) {
        $this->_listId = $_listID;
        return $this;
    }

    public function getListId() {
        return $this->_listId;
    }

    public function print_form() {
        $mcapi = new MCAPI($this->_apiKey);
        $list = $mcapi->lists(array('list_id' => $this->_listId));
        $merge_vars = $mcapi->listMergeVars($this->_listId);
        $groupings = $mcapi->listInterestGroupings($this->_listId);
        if (is_array($merge_vars) && !empty($merge_vars))
            foreach ($merge_vars as $form_field) {
                if ($form_field['public'] == 1 && $form_field['show'] == 1) {
                    $class = 'Forms_MC' . ucfirst($form_field['field_type']) . 'Element';
                    $attributes = array();
                    if ($form_field['req'])
                        $attributes[] = 'required';

                    $element = new $class(
                                    isset($form_field['field_type'])?$form_field['field_type']:null,
                                    isset($form_field['tag'])?$form_field['tag']:null,
                                    isset($form_field['tag'])?$form_field['tag']:null,
                                    isset($form_field['choices'])?$form_field['choices']:null,
                                    isset($form_field['name'])?$form_field['name']:null,
                                    $attributes);
                    $this->getForm()->addElement($element);
                }
            }


        if (is_array($groupings) && !empty($groupings))
            foreach ($groupings as $form_field) {
                if ($form_field['form_field'] != 'hidden') {
                    $class = 'Forms_MC' . ucfirst($form_field['form_field']) . 'Element';
                    $groups = $form_field['groups'];
                    $value = array();
                    foreach ($groups as $group)
                        $value[] = $group['name'];

                    $element = new $class(
                                    isset($form_field['form_field'])?$form_field['form_field']:null,
                                    isset($form_field['id'])?$form_field['id']:null,
                                    isset($form_field['id'])?$form_field['id'] . '[]':null,
                                    $value,
                                    isset($form_field['name'])?$form_field['name']:null);
                    $this->getForm()->addElement($element);
                }
            }

        if ($list['data'][0]['email_type_option']) {
            $values = array('HTML', 'Text', 'Mobile');
            $element = new Forms_MCRadioElement(
                            'radio',
                            'EMAILTYPE',
                            'EMAILTYPE',
                            $values,
                            'Preferred format');
            $this->getForm()->addElement($element);
        }
        return $this->getForm()->generateForm(false, new Forms_MCLayout());
    }

}
?>